#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Data::Filter::Rule::Existence class and it`s subclassess tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
# Comments:
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 12;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Data::Filter::Rule::Existence';

        use_ok('Tester');
        use_ok('Data::Filter::Rule');
        use_ok('Data::Filter::Rule::Atom');
        use_ok('Data::Core');
        use_ok('Data::Path::Parser');
        use_ok($TESTED_CLASS);
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Data::Filter::Rule::Existence::VERSION) if Tester::D();

# Now attempt to create a class instance and check it
my $instance = $TESTED_CLASS->new('existence', 'Node/Name');
isa_ok($instance, $TESTED_CLASS);

# Test the rule interface
is($instance->value(),     'Node/Name',        "Rule interface test 01");
is($instance->datatype(),  'BOOL',             "Rule interface test 02");
is($instance->operation(), undef,              "Rule interface test 03");
is($instance->name(),      'Existence',        "Rule interface test 04");
is($instance->to_string(), 'EXISTS Node/Name', "Rule interface test 05");

# View the created instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D();
