#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Processor module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 8;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Processor';

        use_ok('Tester');
        use_ok('Log::Loger');
        use_ok('Value::Convertor');
        use_ok('Mentat::Processor::Scheduler::Default');
        use_ok('Mentat::Processor::Component');
        use_ok('Mentat::Processor::Component::Dummy');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin:/usr/local/bin';
    }

use Mentat::Core qw(:c_general :c_processor);

# Debug output explicit ON switch
#Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Processor::VERSION

# Now attempt to create a class instance and check it
my $instance = $TESTED_CLASS->new();
isa_ok($instance, $TESTED_CLASS);

# View the created instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D();

#-------------------------------------------------------------------------------

#use Log::Loger;

#Log::Loger->on();

my $CONFIG = {
        CSECTION_LOGER() => {
                log => [
                    #'std:err:info',
                    'syslog::info',
                    'email:test@cesnet.cz;jan.mach@cesnet.cz;Email subject:emerg',
                    'file:./spool/processor.log:info',
                    ],
            },
        CSECTION_PROCESSOR() => {
                path => '/bin:/usr/bin:/usr/local/bin',
                #signals => ['USR1'],
            },
        CSECTION_SCHEDULER() => {
                class => 'Mentat::Processor::Scheduler::Default',
            },
        CSECTION_COMPONENTS() => [
                {
                    class => 'Mentat::Processor::Component::Dummy',
                    attra => '1',
                    attrb => '2',
                    attrc => '3',
                    emited => ['event1','event2','event3'],
                    handled => [['eventa','eha'],['eventb','ehb'],['eventc','ehc']],
                    linked => ['dummy'],
                },
                {
                    class => 'Mentat::Processor::Component::Dummy',
                    attr1 => 'a',
                    attr2 => 'b',
                    attr3 => 'c',
                    emited => ['eventa','eventb','eventc'],
                    handled => [['event1','eh1'],['event2','eh2'],['event3','eh3']],
                    linked => [':dummy'],
                }
            ],
        CSECTION_DAEMON() => {
                pid_file => './spool/processor.pid',
                user     => 'mek',
                group    => 'mek',
            },
    };

#$instance->bootstrap($CONFIG);

#print STDERR Dumper(Log::Loger->get_debug());

#Log::Loger->log('source','debug','Test message - debug');
#Log::Loger->log('source','info','Test message - info');
#Log::Loger->log('source','notice','Test message - notice');
#Log::Loger->log('source','warning','Test message - warning');

#$instance->run();

# View the created instance
#diag("Instance dump 02: " . Dumper($instance)) if Tester::D();

#diag("Order1: " . Dumper($instance->_component_list()));
#diag("Order2: " . Dumper($instance->_component_list(1)));
