#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Reporter::Engine module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 3;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Reporter::Engine';

        use_ok('Tester');
        use_ok('Value::Convertor');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Reporter::Engine::VERSION

my @BOUNDARIES = (
    [[],[]],
);

my $t = 1427374239;
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '5mins', time => $t)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '5mins', time => $t, previous => 1)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '5mins', time => $t, previous => 2)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '5mins', time => $t, previous => 1, noadjust => 1)]));

diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '10mins', time => $t)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '10mins', time => $t, previous => 1)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '10mins', time => $t, previous => 2)]));
diag(Dumper([$TESTED_CLASS->calculate_time_boundaries(period => '10mins', time => $t, previous => 1, noadjust => 1)]));
